;***************************************************************
;* Project Name: 2*4 bites szmolgp
;* Project Description : 
;* A szmolgp a 0..15 szmokon vgzi el a 4 alapmveletet. Az els operandust a kapcsolkon lehet belltani
;* (SW0 a legkisebb, SW3 a legnagyobb helyirtk), a nyomgombok valamelyiknek megnyomsa lltja be az operandust
;* s a mveletet, ekkor az operandus a bal oldali LED-soron, a mveletnek megfelel LED pedig a jobb oldalon jelenik meg.
;* Ezt kveten bellthat a msodik rtk a kapcsolkon, s az INT gomb megnyomsra a mvelet eredmnye a
;* LED-ekre kerl 5 msodpercre, majd trldik a kijelz.
;* Hw: timer, LED-ek, nyomgombok, kapcsolk
;* Author: Horvth va
;* Lab_group: ipdu08
;* Last edited: 2010.04.29
;
;***************************************************************
;* "AVR ExperimentBoard" port assignment information:
;***************************************************************
;*
;* LED0(P):PortC.0          LED4(P):PortC.4
;* LED1(P):PortC.1          LED5(P):PortC.5
;* LED2(S):PortC.2          LED6(S):PortC.6
;* LED3(Z):PortC.3          LED7(Z):PortC.7        INT:PortE.4
;*
;* SW0:PortG.0     SW1:PortG.1     SW2:PortG.4     SW3:PortG.3
;* 
;* BT0:PortE.5     BT1:PortE.6     BT2:PortE.7     BT3:PortB.7
;*
;***************************************************************
;*
;* AIN:PortF.0     NTK:PortF.1    OPTO:PortF.2     POT:PortF.3
;*
;***************************************************************
;*
;* LCD1(VSS) = GND         LCD9(DB2): -
;* LCD2(VDD) = VCC         LCD10(DB3): -
;* LCD3(VO ) = GND         LCD11(DB4): PortA.4
;* LCD4(RS ) = PortA.0     LCD12(DB5): PortA.5
;* LCD5(R/W) = GND         LCD13(DB6): PortA.6
;* LCD6(E  ) = PortA.1     LCD14(DB7): PortA.7
;* LCD7(DB0) = -           LCD15(BLA): VCC
;* LCD8(DB1) = -           LCD16(BLK): PortB.5 (1=Backlight ON)
;*
;***************************************************************

.include "m128def.inc" ; Definition file for ATmega128 
;* Program Constants 
.equ const =$00 ; Generic Constant Structure example  
;* Program Variables Definitions 
.def temp =r16 ; Temporary Register example 

.def state=r21 ; Ebben troljuk hogy melyik llapotban vagyunk
.def operator=r25 ; ebben pedig hogy milyen mveletet kell vgrehajtani
.def num1 =r24	; ebben troljuk az elsknt bevitt szmot
.def num2 =r23	; ebben troljuk a msodikknt bevitt szmot
.def counter =r22 ; a LED-re val kiiratshoz, a visszaszmlls
.def beolvasott = r18 ;beolvasott szmot ebben trolom el

;*************************************************************** 
;* Reset & Interrupt Vectors  
.cseg 
.org $0000 ; Define start of Code segment 
	jmp RESET ; Reset Handler, jmp is 2 word instruction 

	reti ; INT0 Handler on $0002, dummy 
	nop 
	reti ; INT1 Handler, if INTn used, 'reti' and 'nop' 
	     ; will be replaced by 'jmp INTn_Handler_Address'
	nop 
	reti ; INT2 Handler 
	nop 
	reti ; INT3 Handler 
	nop 
	reti ; INT4 Handler 
	nop 
	reti ; INT5 Handler 
	nop 
	reti ; INT6 Handler 
	nop 
	reti ; INT7 Handler 
	nop 
	reti ; Timer2 Compare Match Handler 
	nop 
	reti ; Timer2 Overflow Handler 
	nop 
	reti ; Timer1 Capture Event Handler 
	nop 
	reti ; Timer1 Compare Match A Handler 
	nop 
	reti ; Timer1 Compare Match B Handler 
	nop 
	reti ; Timer1 Overflow Handler 
	nop 
;	reti ; Timer0 Compare Match Handler 
;	nop 
    jmp TIMER_IT1 ; timer interrupt belltsa

	reti ; Timer0 Overflow Handler 
	nop 
	reti ; SPI Transfer Complete Handler 
	nop 
	reti ; USART0 RX Complete Handler 
	nop 
	reti ; USART0 Data Register Empty Hanlder 
	nop 
	reti ; USART0 TX Complete Handler 
	nop 
	reti ; ADC Conversion Complete Handler 
	nop 
	reti ; EEPROM Ready Hanlder 
	nop 
	reti ; Analog Comparator Handler 
	nop 
	reti ; Timer1 Compare Match C Handler 
	nop
	reti ; Timer3 Capture Event Handler 
	nop 
	reti ; Timer3 Compare Match A Handler 
	nop 
	reti ; Timer3 Compare Match B Handler 
	nop 
	reti ; Timer3 Compare Match C Handler 
	nop 
	reti ; Timer3 Overflow Handler 
	nop 
	reti ; USART1 RX Complete Handler 
	nop 
	reti ; USART1 Data Register Empty Hanlder 
	nop 
	reti ; USART1 TX Complete Handler 
	nop 
	reti ; Two-wire Serial Interface Handler 
	nop 
	reti ; Store Program Memory Ready Handler 
	nop 
	
;*************************************************************** 
;* MAIN program, Initialisation part
.org $0046;
M_INIT:
RESET: 
;* Stack Pointer init, 
;  Set stack pointer to top of RAM 
	ldi temp, LOW(RAMEND) ; RAMEND = max address in RAM"
	out SPL, temp 	      ; RAMEND value in "m128def.inc" 
	ldi temp, HIGH(RAMEND) 
	out SPH, temp 

;< Insert your other initialisation code here> 

;******************* TIMER BELLTSA ************************

	ldi r18, 216			; 50 Hz-es timer            
//	ldi r18, 5			    ;-> debuggolshoz
	out OCR0, r18           

	ldi r18, 0x00
	out TCNT0, r18        ; timer nullzsa

	ldi r16,0b00001111
    out TCCR0,temp ; Timer 0 TCCR0 regiszter


	ldi temp,0b00000010
	out TIMSK,temp ; Timer IT Mask regiszter
 

 ;******************* PORTOK BELLTSA *************************

	ldi state, 0xFF
	ldi r16, 0xFF
 	out PORTC, r16
	ldi r16,0xFF
	out DDRC, r16 ; kimenetre lltjuk a C portot , LEDek
	
	ldi r16, 0xFF
 	sts PORTG, r16
	ldi r16,0x00
	sts DDRG, r16 ; bemenetre lltjuk a G portot ; SWITCHEK
	
	ldi r16, 0xFF
 	out PORTE, r16
	out PORTB, r16
	ldi r16,0x0F
	out DDRE, r16	; bemenetrelltjuk az E7-E4 ot ( E4 = int ) GOMBOK
	ldi r16, 0x7F	; s a B7 et

;***************************************************************

	sei ; globlis IT engedlyezve



;* MAIN program, Endless loop part
 
M_LOOP: 



	jmp M_LOOP ; Endless Loop  


;*************************************************************** 
;* Subroutins, Interrupt routins


;**************************************************************
; Operandus beolvassra segd subrutin
; r16-ban visszaadja hogy melyik mvelet gombja van lenyomva 
;( 1: sszeads | 2: kivons | 3: szorzs | 4 :oszts | 0: egyiksem
READ_OPERATORS:
	push r20
	push r19	
		in r20, PINE
		in r19, PINB
		
		neg r20					;neglom, mert a gombok alacsony aktvak
		neg r19
		mov r16,r20
		andi r16,0b00100000		;sszesels, hogy a btn0 gomb van-e megnyomva
		;ha igen, akkor a megfelel biten 1 lesz, akkor sszeadok, klnben vizsglom a kivons gombjra

		cpi r16,0
		breq KIVONAS
		ldi r16,1				; sszeads
		jmp OP_VEGE
KIVONAS:	
		mov r16,r20
		andi r16,0b01000000		;btn1 van-e megnyomva

		cpi r16,0
		breq SZORZAS
		ldi r16,2				; kivons
		jmp OP_VEGE
SZORZAS:
		mov r16,r20
		andi r16,0b10000000		;btn2 van-e megnyomva

		cpi r16,0
		breq OSZTAS
		ldi r16,4				; szorzs
		jmp OP_VEGE

OSZTAS:
		mov r16,r19
		andi r16,0b10000000		;btn3 van-e megnyomva

		cpi r16,0
		breq DEFAULT
		ldi r16,8				; oszts
		jmp OP_VEGE

DEFAULT:
		ldi r16,0				;egybknt nulla, ha semmi sincs megnyomva

OP_VEGE:
	pop r19
	pop r20
ret

;**************************************************************
; Operandus beolvassra segd subrutin
; eredmny az r16,ban | num1, num2, s operator regisztereket hasznl
CALC_RESULT:
	push r20
	
	cpi operator,1 		; ha az opertor 1 volt, sszeads
	brne KIVON			;klnben nzem a kivonsra
	
	mov r16,num1		;temp regiszterben sszeadom a szmokat
	add r16,num2
	jmp RES_VEGE	

KIVON:
	cpi operator,2	    ; ha az opertor 2 volt, kivons
	brne SZORZ
	
	mov r16,num1		;temp regiszterben kivonom a szmokat, ha a kivonand nagyobb, akkor tcsordul...
	sub r16,num2
	jmp RES_VEGE

SZORZ:
	cpi operator,4		; szorzs
	brne OSZT

	mul num1,num2		; eredmny R0-R1 regiszterprosban
	mov r16,r0			; de csak az als 8 bitet iratjuk ki vele
	jmp RES_VEGE
OSZT:
	cpi operator,8		; oszts
	
	ldi r16,0			; hnyados
	mov r20,num1		; osztand
	cpi r20, 0			; ha nullval akarunk osztani, akkor nullt tegyen ki
	breq NEM_JO
	cp num1, num2		;ha a hnyados nagyobb vagy egyenl mint az osztand, akkor osztja
	brsh OSZTO_CIKLUS	; klnben nem j, s megint nulla lesz kint

NEM_JO:
	ldi r16,0			; hogy nulla legyen kinn a LED-eken
	jmp RES_VEGE
	
OSZTO_CIKLUS:			; egszoszts
	cp	r20,num2	
	brlo RES_VEGE		; ha kisebb az r20 mint a num2 vge az osztsnak
	
	sub r20,num2
	inc r16
	jmp OSZTO_CIKLUS
	
RES_VEGE:			
	pop r20
ret

;**************************************************************
; Szm beolvasshoz segd subrutin
; beolvasott-ban tr vissza a beolvasott szmmal

READ_NUMBER:
	push r20
	push r19
		lds r20, PING 			; g port beolvassa
		andi r20, 0x1B 			; a nem kell bitek nullzsa
		
		mov r19,r20				;a switckek nem sorrendben vannak, ezrt kell
		andi r19,0x10			; g4-et t kell mozgatni a harmadik bitre
		lsr r19
		lsr r19
				 
		andi r20,0b00001011	
		or r20,r19				; sszevagyolom a g4-et, ami a harmadik biten van s a tbbi kapcsolt
		
		mov beolvasott, r20

	pop r19
	pop r20
ret


;**************************************************************
; * Timer interrupt
TIMER_IT1 :
	push r16
	in r16,SREG
	push r16
	push r20


	cpi state,0	
	brne MASODIK
	; mvelet beolvassa
	call READ_OPERATORS
	cpi r16, 0
	breq IT_VEGE			; ha nincs lenyomva gomb, nem csinlunk semmit
	mov operator,r16		; bemsolom az opertorba a mveletet
	call READ_NUMBER		; els szm beolvassa
	mov num1,beolvasott		; beteszem num1-be a beolvasott szmot
	ldi state,1				; llapot => msodik szmra vrok

	mov r20,operator		; bal oldali LED-eken lesz a szm, a jobb oldalin a mvelet
	lsl r20
	lsl r20
	lsl r20					; ngy bittel elshiftelem balra az opertort
	lsl r20
	or beolvasott, r20		; sszevagyolom ket a beolvasottba
	out PORTC, beolvasott	; majd kirom ket a LED-re

	jmp IT_VEGE

MASODIK:
	cpi state,1
	brne KIIRATAS			; ha mr state 2, akkor tugrik a kiratshoz
	
	in r16,PINE
	neg r16					; beolvasom s neglom
	andi r16,0x10			; nzem a megfelel gombot, hogy meg van-e nyomva
	cpi r16,0
	breq IT_VEGE			; ha nincs lenyomva nem csinlunk semmit

	call READ_NUMBER
	mov num2,beolvasott		; msodik szm beolvassa a num2-be

	call CALC_RESULT		; eredmny kiszmolsa
	ldi state,2				; state = 2, eredmny kirsa llapot

	out PORTC,r16			; kiratjuk ledekre az eredmnyt
	ldi counter,0

KIIRATAS:					; 5sec-ig van kinn az eredmny, addig nem reagl a program semmire
	cpi counter,250
	brsh KIIR_VEGE			; amg nem ri el a 250-et a counter, addig nvelem mindig eggyel
	
	inc counter			
	jmp IT_VEGE		

KIIR_VEGE:					; ha elrte a 250-et, akkor a regisztereket trlm
	ldi num1,0
	ldi num2,0
	ldi operator,0
	ldi state,0				; megint vrja az els szmot
	out PORTC,state			; LEDek trlse

	
IT_VEGE:  
	pop r20
	pop r16
	out SREG, r16
	pop r16


reti
















